'FFSubmenu=Bilderlisten
'FFName=Umbenennen & Kopieren
'
' Benennt die Bilder der aktuellen virtuellen 
' Bilderliste nach einem Nummerierungs-Schema um
' oder erzeugt auf der Grundlage des Nummerierungs-Schema
' Kopien mit neuem Namen
' KGsoft (praetor) 
' Version 1.6 vom 04.02.2012
' Version 2.0 vom 16.10.2013	Kopieren ohne Umbenennen zugefgt
' Version 2.2 vom 03.03.2014	kleine kosmetische Korrektur
' Version 2.3 vom 15.06.2016	kein Fehler mehr bei Listennamen mit Leerzeichen am Anfang oder Ende
' Version 3.1 vom 03.01.2021	Erstellung von Verknpfungen,Fortschrittsanzeige und Abschlussmeldung
' Version 3.2 vom 17.01.2021	statt Verknpfung symbolischen Hardlinks, Verwendung von ln.exe, https://schinagl.priv.at/nt/ln/ln.html   

option explicit
const Version = "V 3.2"
const RegSchluessel = "PictureListRename"						'Registryschlssel
Dim startpraefix, praefix, stellen, start, schrittweite  
Dim bild, i, dateiname, zusatz, neubild
Dim behalten
Dim Modus
Dim Taste, aktDialog, mark
Dim zielordner
Dim hinweis, fehlerflag
Dim Abbruchflag
Dim btxt1, btxt2, MTaste
Dim listwechsel
Dim aktulist
Dim alles_vorbereitet
Dim FS_start

Dim fso
Dim f
Dim oShell
Dim objShortcut
Const ForReading = 1, ForWriting = 2
Const Inidatei = "symblink.ini"
Const pingdatei = "symblinkping.txt"		' Info vom Skript SymbLinkErstellung, dass es mit Adminrechten luft
Const SymbLinkErstellung = "symblink_create.vbs"	' Skript erstellt mit Adminrechten symolische Links

Set oShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")


Call Dialogaufbau
Call Dialog_anzeigen
if alles_vorbereitet = True Then
	Call Dialogaufbau_Meldung
	Call Listeninhalt_bearbeiten
end if 
  
Sub Dialog_anzeigen
	' Prfung auf (allein zulssige) virtuelle Liste
	if FF_IListGetCurrentList = "" Then
		Msgbox "Es wurde noch keine Bilderliste angelegt." & vbNewLine & "Das Script wird beendet.",64
		Exit Sub
	End If
	If ReadIni(FF_GetFFPathEx(1) & "\FixFotoImageList.ini", Trim(FF_IListGetCurrentList), "Type" ) <> 2 Then	' keine virtuelle Liste
		Msgbox "Die aktuelle Bilderliste <" & FF_IListGetCurrentList & "> ist keine virtuelle Liste." & vbNewLine & vbNewLine & "Das Script wird beendet.",64
		Exit Sub
	End If
	If FF_IListGetCount(FF_IListGetCurrentList()) = 0 Then
		Msgbox "Die aktuelle Bilderliste <" & FF_IListGetCurrentList & "> enthlt keine Bilder ." & vbNewLine & vbNewLine & "Das Script wird beendet.",64
		Exit Sub
	End If
	
	FF_IListUpdate FF_IListGetCurrentList		' sicherheitshalber Aktualisierung der Liste
	
	Do								' Auswertung Button im Dialog
		Taste = FF_ShowDialog("Bilder der Liste umbennen/kopieren")
		Select Case Taste
			Case "umbenen"			' Umbenennen/Ort beibehalen
				FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 1
				FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0
				
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
				' Schema			
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
			Case "kopie"			' Unbenennen/Kopieren
				FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 1
				FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0

				FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
				if zielordner <> "" Then
					FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
				End If
				' Schema
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
			Case "nurkopie_opt"		' nur Kopieren
				FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 1
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0

				FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
				if zielordner <> "" Then
					FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
				End If
				' Schema
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 0
				
			Case "verkn_umn_opt"			' Verknpfung erzeugen & Unbenennen
				FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 1
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0

				FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
				
				' Schema
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
				
			Case "verkn_opt"			' Verknpfung erzeugen
				FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
				FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 1

				FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
				
				' Schema
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 0
				FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 0
			Case "Zielordner" & vbNewLine & "whlen"
				zielordner = Ordnerauswahl
				if zielordner <> "" Then
					if len (Zielordner) < 55 Then
						FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", zielordner
					Else
						FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", Left(Zielordner, 5) & " ... " & Right (Zielordner, 45)			' Anzeige verkrzen
					End If
					FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
				Else
					FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", "** Ausgangsordner **"
					FF_SetControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
					FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
				End If
			Case "Ausfhren"
				' Dialog auswerten
				startpraefix = FF_GetControl("Bilder der Liste umbennen/kopieren", "praefix_edit")
				praefix = FF_GetControl("Bilder der Liste umbennen/kopieren", "binde")
				stellen = FF_GetControl("Bilder der Liste umbennen/kopieren", "combo_stellen")
				start = FF_GetControl("Bilder der Liste umbennen/kopieren", "sw")
				schrittweite = FF_GetControl("Bilder der Liste umbennen/kopieren", "schritt")
				behalten = FF_GetControl("Bilder der Liste umbennen/kopieren", "altnam")
				REM dateiumbenen = FF_GetControl("Bilder der Liste umbennen/kopieren", "umbenen")
				REM nurkopie = FF_GetControl("Bilder der Liste umbennen/kopieren", "nurkopie_opt")
				if FF_GetControl("Bilder der Liste umbennen/kopieren", "umbenen") = 1 then Modus = 1		' Umbenennen/Ort beibehalen
				if FF_GetControl("Bilder der Liste umbennen/kopieren", "kopie") = 1 then Modus = 2			' Unbenennen/Kopieren
				if FF_GetControl("Bilder der Liste umbennen/kopieren", "nurkopie_opt") = 1 then Modus = 3	' nur Kopieren
				if FF_GetControl("Bilder der Liste umbennen/kopieren", "verkn_umn_opt") = 1 then Modus = 4	' Hardlink/Umbenennen
				if FF_GetControl("Bilder der Liste umbennen/kopieren", "verkn_opt") = 1 then Modus = 5		' nur Hardlink
				listwechsel = FF_GetControl("Bilder der Liste umbennen/kopieren", "bool_listwechsel")
				Select Case Modus
					Case 1, 4, 5		' ** Ausgansgordner ** bei "nur Kopieren" und Verknpfung nicht erlaubt
						If Zielordner = "" Then
							Msgbox "Bitte zunchst einen konkreten Zieolrdner whlen." & vbNewLine & vbNewLine & "** Ausgangsordner ** ist nicht zulssig fr:" & vbNewLine &  "    *  'Kopie erzeugen und Name beibehalten'" & vbNewLine & "    *  das Erzeugen von Verknpfungen", 48
							alles_vorbereitet = False
						Else
							alles_vorbereitet = True
							exit do
						End IF
					Case 2, 3
						alles_vorbereitet = True
						exit Do						
				End Select
			Case "?"
				REM Call Hilfetext
				Dim HelpDialogName
				HelpDialogName = "Kurze Erluterung"
				Call BildView100 (FF_GetScriptPath & "\virlisthelp.png", HelpDialogName)
				Do		
					Select Case FF_ShowDialog(HelpDialogName)
						Case "OK", "CANCEL"
							FF_CloseDialog HelpDialogName
						Exit Do
					End Select
				Loop
			Case "Abbruch", "CANCEL"
				REM Call Registry_Schreiben		' nur Test
				FF_CloseDialog "Bilder der Liste umbennen/kopieren"			
				REM Abbruch = True
				Exit Sub
			End Select
	loop
	
	Call Registry_Schreiben
	FF_CloseDialog "Bilder der Liste umbennen/kopieren"
End Sub

Sub Listeninhalt_bearbeiten
	hinweis = 1									' Info pro Durchlauf nur 1x
	Abbruchflag = 0								' Bearbeitung nach Doublette abbrechen
	FS_start = True								' Fr Erstaufruf der Fortschrittsanzeige
	' **fr Modus 4 und 5
	If fso.FileExists(FF_GetScriptPath & "\" & Inidatei) Then	' ggf. vorhandene Inidatei lschen
		fso.DeleteFile FF_GetScriptPath & "\" & Inidatei
	end if
	Set f = fso.OpenTextFile(FF_GetScriptPath & "\" & Inidatei, ForWriting, True)
	' **
	for i = 0 to FF_IListGetCount(FF_IListGetCurrentList) - 1		' Hauptschleife, alle Bilder der Liste
		if Abbruchflag = 1 Then
			Exit Sub
		End If
		fehlerflag = 0
		bild = FF_IListGetFile(FF_IListGetCurrentList, i)				' Ausgangsbild mit Pfad
		dateiname = Right(bild, Len (bild) - InStrRev(bild, "\",-1, 1))	' nur Dateiname des Ausgangsbildes

		Select Case Modus 		' Prfix zusammenbauen mur fr Modus 1, 2, 4
			Case 1, 2, 4
				if Len(start) < CInt(stellen) Then
					zusatz = String(stellen - Len(start) , "0") & start & praefix
				Else
					zusatz = start & praefix
				End If
				If behalten then 
					dateiname = startpraefix & zusatz & dateiname
				Else
					dateiname = startpraefix & zusatz & "." & Right(bild, Len (bild) - InStrRev(bild, ".",-1, 1)) ' neuer Name jetzt fertig
				End If
				start = CInt(start) + CInt(schrittweite)	
				neubild = Left(bild, InStrRev(bild, "\",-1, 1)) & dateiname							' neuer Name mit Pfad
			Case 5
				neubild = bild
		End Select		
		
		' fr Verknpfungen
		REM Select Case Modus
			REM Case 4, 5			' fr Verknpfungen Dateiendung auf .lnk ndern, Pfad abtrennen
				REM neubild = fso.GetBaseName(neubild) & ".lnk"		
					neubild = fso.GetFileName(neubild)
		REM End Select
		
		Select Case Modus
			Case 1			' Umbenennen/Ort beibehalen
				if hinweis = 1 then
					FF_SetControl "Meldung","img1", bild
					FF_SetControl "Meldung", "meld1",  "Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> umbenannt!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & neubild & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach die umbenannten Bilder."
					do								' Auswertung Button im Dialog
						MTaste = FF_ShowDialog("Meldung")
						Select Case MTaste
							Case "OK"			' los gehts
								Exit Do
							Case "Abbrechen", "CANCEL"	' alles abbrechen
								FF_CloseDialog "Meldung"
								Exit Sub
						End Select
					loop
				End If  
				hinweis = 0
				
				Call RenameFile (bild, dateiname)
				if fehlerflag = 0 Then		' kein Problem beim Umbenennen
					FF_IListDeleteIndex FF_IListGetCurrentList, i
					FF_IListInsertFile FF_IListGetCurrentList, neubild, i
				End If
				
			Case 2			' Unbenennen/Kopieren (unter neuem Namen im selben Ordner oder anderem Ordner)
				if hinweis = 1 then
					FF_SetControl "Meldung","img1", bild
					if Zielordner = "" Then							' ** Ausgansgordner **
						FF_SetControl "Meldung", "meld1","Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> unter neuem Namen kopiert!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & neubild & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach die neuen Bilder."
					else 	' Liste enthlt die Ausgangsordner
						if listwechsel = 1 Then		' Liste wird auf Zielordner gesetzt
							FF_SetControl "Meldung", "meld1","Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> unter neuem Namen kopiert!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & Zielordner & "\" & dateiname & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach die neuen Bilder."
						Else
							FF_SetControl "Meldung", "meld1","Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> unter neuem Namen kopiert!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & Zielordner & "\" & dateiname & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach weiterhin die ursprnglichen Bilder."
						End If
					End If

					do								' Auswertung Button im Dialog
						MTaste = FF_ShowDialog("Meldung")
						Select Case MTaste
							Case "OK"			' los gehts
								Exit Do
							Case "Abbrechen", "CANCEL"	' alles abbrechen
								FF_CloseDialog "Meldung"
								Exit Sub
						End Select
					loop
				End If
				hinweis = 0
				if Zielordner = "" Then				' ** Ausgansgordner **
					Call WriteNewFile (bild, neubild)
					if fehlerflag = 0 Then			' kein Problem beim Kopieren
						FF_IListDeleteIndex FF_IListGetCurrentList, i
						FF_IListInsertFile FF_IListGetCurrentList, neubild, i
					End If
				Else
					Call WriteNewFile (bild, Zielordner & "\" & dateiname)
					if fehlerflag = 0 Then			' kein Problem beim Kopieren
						if listwechsel = 1 then		' List wird auf Zielverzeichnis gesetzt
							FF_IListDeleteIndex FF_IListGetCurrentList, i
							FF_IListInsertFile FF_IListGetCurrentList, Zielordner & "\" & dateiname, i
						End If
					End If
				End If			
		
			Case 3			' nur Kopieren
				if hinweis = 1 then
					FF_SetControl "Meldung","img1", bild
					If listwechsel = 1 Then		' Liste wird auf Zielordner gesetzt
						FF_SetControl "Meldung", "meld1","Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> kopiert!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & Zielordner & "\" & dateiname & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach die kopierten Bilder im Zielordner."
					Else
						FF_SetControl "Meldung", "meld1","Es werden alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> kopiert!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von : " & bild & vbNewLine & "zu   : " & Zielordner & "\" & dateiname & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach weiterhin die ursprnglichen Bilder."
					End If
					
					Do								' Auswertung Button im Dialog
						MTaste = FF_ShowDialog("Meldung")
						Select Case MTaste
							Case "OK"			' los gehts
								Exit Do
							Case "Abbrechen", "CANCEL"	' alles abbrechen
								FF_CloseDialog "Meldung"
								Exit Sub
						End Select
					loop
				End If
				hinweis = 0
				
				Call WriteNewFile (bild, Zielordner & "\" & dateiname)
				if fehlerflag = 0 Then			' kein Problem beim Kopieren
					if listwechsel = 1 then		' List wird auf Zielverzeichnis gesetzt
						FF_IListDeleteIndex FF_IListGetCurrentList, i
						FF_IListInsertFile FF_IListGetCurrentList, Zielordner & "\" & dateiname, i
					End If
				End If
				
			Case 4			' Verknpfung erzeugen/Umbenennen
				If hinweis = 1 then
					FF_SetControl "Meldung","img1", bild
					FF_SetControl "Meldung", "meld1","Es werden fr alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> Verknpfungen unter neuem Namen erzeugt!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von: " & bild & vbNewLine & "wird erzeugt: " & Zielordner & "\" & neubild & " [LINK]" & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach weiterhin die ursprnglichen Bilder."

					do								' Auswertung Button im Dialog
						MTaste = FF_ShowDialog("Meldung")
						Select Case MTaste
							Case "OK"			' los gehts
								FF_CloseDialog "Meldung"
								Exit Do
							Case "Abbrechen", "CANCEL"	' alles abbrechen
								FF_CloseDialog "Meldung"
								Exit Sub
						End Select
					loop
				End If
				hinweis = 0 
			
				' Erstellung der Verknpfungen, gleichlautende Dateien werden berschrieben
				REM Set objShortcut = oShell.CreateShortcut(Zielordner & "\" & neubild)
				REM objShortcut.TargetPath = bild
				REM objShortcut.IconLocation = "%SystemRoot%\System32\SHELL32.dll, 325"		'stilisiertes Foto
				REM objShortcut.Description = neubild
				REM objShortcut.Save
				
				' symblink.ini schreiben fr Erstellung Symblink ber zweites Skript
				f.Write bild & "," & Zielordner & "\" & neubild & vbNewLine
											
			Case 5			' nur Verknpfung erzeugen
				If hinweis = 1 then
					FF_SetControl "Meldung","img1", bild
					FF_SetControl "Meldung", "meld1","Es werden fr alle Bilder der Bilderliste <" & FF_IListGetCurrentList & "> Verknpfungen erzeugt!" & vbNewLine & vbNewLine &"Fr das erste Bild gilt:" & vbNewLine & "von: " & bild & vbNewLine & "wird erzeugt: " & Zielordner & "\" & neubild & " [LINK]" & vbNewLine & vbNewLine & "Die Bilderliste enthlt danach weiterhin die ursprnglichen Bilder."
					do								' Auswertung Button im Dialog
						MTaste = FF_ShowDialog("Meldung")
						Select Case MTaste
							Case "OK"			' los gehts
								FF_CloseDialog "Meldung"
								Exit Do
							Case "Abbrechen", "CANCEL"	' alles abbrechen
								FF_CloseDialog "Meldung"
								Exit Sub
						End Select
					loop
				End If
				hinweis = 0 
				
				' Erstellung der Verknpfungen, gleichlautende Dateien werden berschrieben
				REM Set objShortcut = oShell.CreateShortcut(Zielordner & "\" & neubild)
				REM objShortcut.TargetPath = bild
				REM objShortcut.IconLocation = "%SystemRoot%\System32\SHELL32.dll, 325"		'stilisiertes Foto
				REM objShortcut.Description = neubild
				REM objShortcut.Save
				REM Set objShortcut = Nothing
				
				' symblink.ini schreiben fr Erstellung Symblink ber zweites Skript
				f.Write bild & "," & Zielordner & "\" & neubild & vbNewLine
		End Select
		
		Select Case Modus
			case 1, 2, 3
				' Fortschritt
				REM If i mod 5 = 1 Then		' nur bei jeder 5. Datei --> hat Stabilitt nicht verbessert
					FF_SetControl "Meldung","progress",i/(FF_IListGetCount(FF_IListGetCurrentList) - 1) *100
					FF_RefreshDialog "Meldung"
				REM end if
		end select
	Next
	
	select case Modus
		case 4, 5
			f.close
			'** Start Dialog Erstellung symbolischer Links **
			FF_AddDialog "Erstellung symbolischer Links",168,30
			FF_AddControl "Erstellung symbolischer Links","Die symbolischen Links werden erstellt. Einen Augenblick bitte.","STATIC",8,8,157,11
			'** End Dialog Erstellung symbolischer Links **
			FF_OpenDialog "Erstellung symbolischer Links"
			
			oShell.run FF_GetScriptPath & "\" & SymbLinkErstellung, , True			
			FF_Sleep 1000		' Abfrage der Benutzerkontensteuerung hlt zwar das System insgesamt an, Aber sodann braucht das zweite Skript einen Moment, um die pingdatei zu erstellen
			
			If fso.FileExists(FF_GetScriptPath & "\" & pingdatei) Then			' Adminrechte wurden erteilt	
				while fso.FileExists(FF_GetScriptPath & "\" & Inidatei)
					' Schleife, bis die  Inidatei durch das zweite Skript gelscht wurde
				wend
				FF_CloseDialog "Erstellung symbolischer Links"
				fso.deleteFile FF_GetScriptPath & "\" & pingdatei 	' lschen, damit definierter Zustand fr nchste Runde
			Else
				FF_CloseDialog "Erstellung symbolischer Links"
				Msgbox "Die fr die Erstellung der symbolische Verknpfungen erforderlichen Adminrechte wurden nicht erteilt." & vbNewLine & vbNewLine & "Die Verknpfungen knnen NICHT erzeugt werden.", 48, "Erstellung symbolischer Links"
				If fso.FileExists(FF_GetScriptPath & "\" & pingdatei) Then	' sicherheitshalber lschen, damit definierter Zustand fr nchste Runde
					fso.deleteFile FF_GetScriptPath & "\" & pingdatei 	
				end if
			end if
	end select
	
	FF_IListUpdate FF_IListGetCurrentList
	FF_IListSave FF_IListGetCurrentList
	Set oShell = Nothing
	Set fso = Nothing
	Msgbox "Bearbeitung abgeschlossen", 64, "Bilder der Liste umbennen/kopieren"
End Sub

Sub Dialogaufbau
	aktulist = 	FF_IListGetCurrentList()
	'** Start Dialog Bilder der Liste umbennen/kopieren **
	FF_AddDialog "Bilder der Liste umbennen/kopieren",172,206
	FF_AddControl "Bilder der Liste umbennen/kopieren","aktuelle Bilderliste","GROUP",3,3,166,24
	FF_AddControl "Bilder der Liste umbennen/kopieren","Verfahren","GROUP",3,32,166,96
	FF_AddControl "Bilder der Liste umbennen/kopieren","Umbenenn-Schema definieren","GROUP",3,133,166,49
	FF_AddControl "Bilder der Liste umbennen/kopieren","Startwert","STATIC",7,154,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","sw","SLEDIT",53,154,20,10
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","sw",2
	FF_AddControl "Bilder der Liste umbennen/kopieren","Schrittweite","STATIC",7,168,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","schritt","SLEDIT",53,168,20,10
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","schritt",2
	FF_AddControl "Bilder der Liste umbennen/kopieren","Stellen","STATIC",89,141,33,10
	FF_AddControl "Bilder der Liste umbennen/kopieren","Bindewort","STATIC",89,154,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","binde","SLEDIT",126,154,33,10
	FF_AddControl "Bilder der Liste umbennen/kopieren","altnam","BOOL",150,169,9,9
	FF_AddControl "Bilder der Liste umbennen/kopieren","alten Namen anfgen","STATIC",89,168,56,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","umbenen","BOOL",116,41,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","umbenen",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren","kopie","BOOL",116,52,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","kopie",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren","Umbenennen und Speicherort beibehalten","STATIC",7,40,101,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","Kopie erzeugen und Umbenennen","STATIC",7,51,83,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","Ausfhren","BUTTON",132,190,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","Abbruch","BUTTON",88,190,34,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","?","BUTTON",8,190,11,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","combo_stellen","COMBO",139,141,20,10
	FF_AddControl "Bilder der Liste umbennen/kopieren","Zielordner" & vbNewLine & "whlen","BUTTON",129,74,36,20
	FF_AddControl "Bilder der Liste umbennen/kopieren","edit_ordner","EDIT",7,101,158,10
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","edit_ordner",2048
	FF_AddControl "Bilder der Liste umbennen/kopieren","bool_listwechsel","BOOL",150,115,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","bool_listwechsel",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren","Liste enthlt die neuen Dateien","STATIC",69,114,79,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","praefix_edit","SLEDIT",53,141,20,10
	FF_AddControl "Bilder der Liste umbennen/kopieren","Prfix","STATIC",7,141,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","Kopie erzeugen und Name beibehalten ","STATIC",7,62,94,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","nurkopie_opt","BOOL",116,63,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","nurkopie_opt",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren",Version,"STATIC",29,190,33,11
	FF_AddControl "Bilder der Liste umbennen/kopieren",aktulist,"STATIC",7,12,158,10
	FF_AddControl "Bilder der Liste umbennen/kopieren","verkn_umn_opt","BOOL",116,74,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","verkn_umn_opt",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren","verkn_opt","BOOL",116,85,9,9
	FF_SetControlStyle "Bilder der Liste umbennen/kopieren","verkn_opt",16384
	FF_AddControl "Bilder der Liste umbennen/kopieren","Verknpfung erzeugen und Umbenennen","STATIC",7,73,99,11
	FF_AddControl "Bilder der Liste umbennen/kopieren","Verknpfung erzeugen und Name beibehalten","STATIC",7,84,107,11
	'** End Dialog Bilder der Liste umbennen/kopieren **
	
	' zustzliche Wert setzen
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 1
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 2
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 3
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 4
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 5
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 6
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 7
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", 8
	
	if FF_GetProfile (RegSchluessel, "Initialisierung") = "" then
		Call Initalisierung_Registry
	end if
	
	' Werte aus der Registry setzen
	FF_SetControl "Bilder der Liste umbennen/kopieren","praefix_edit", FF_GetProfile(RegSchluessel,"praefix1")
	FF_SetControl "Bilder der Liste umbennen/kopieren","binde", FF_GetProfile(RegSchluessel,"praefix")
	FF_SetControl "Bilder der Liste umbennen/kopieren","combo_stellen", FF_GetProfile(RegSchluessel,"stellen")
	FF_SetControl "Bilder der Liste umbennen/kopieren","sw", FF_GetProfile(RegSchluessel,"start")
	FF_SetControl "Bilder der Liste umbennen/kopieren","schritt", FF_GetProfile(RegSchluessel,"schrittweite")
	FF_SetControl "Bilder der Liste umbennen/kopieren","altnam", FF_GetProfile(RegSchluessel,"behalten")
	if FF_GetProfile(RegSchluessel,"umbenen") = "1" then 
		FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 1
		FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
		' Schema
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
	End If
	if FF_GetProfile(RegSchluessel,"kopie") = "1" then
		FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 1
		FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
		if zielordner <> "" Then
			FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
		End If
		' Schema
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
	End If
	
	if FF_GetProfile(RegSchluessel,"nurkopie") = "1" then
		FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 1
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
		if zielordner <> "" Then
			FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
		End If
		' Schema
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 0
	End If
		
	if FF_GetProfile(RegSchluessel,"verkn_umn_opt") = "1" then 
		FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 1
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0		
		' Schema
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 1
	End If
	
	if FF_GetProfile(RegSchluessel,"verkn_opt") = "1" then
		FF_SetControl "Bilder der Liste umbennen/kopieren", "umbenen", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "kopie", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "nurkopie_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_umn_opt", 0
		FF_SetControl "Bilder der Liste umbennen/kopieren", "verkn_opt", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "Zielordner" & vbNewLine & "whlen", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "edit_ordner", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
		' Schema
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "praefix_edit", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "sw", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "schritt", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "binde", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "altnam", 0
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "combo_stellen", 0
	End If
	
	Zielordner = FF_GetProfile(RegSchluessel,"zielordner")
	if len (Zielordner) < 55 Then
		FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", zielordner
	Else
		FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", Left(Zielordner, 5) & " ... " & Right (Zielordner, 45)			' Anzeige verkrzen
	End If
	if Zielordner = "" then FF_SetControl "Bilder der Liste umbennen/kopieren","edit_ordner", " ** Ausgangsordner **"
	'FF_ActivateControl"Bilder der Liste umbennen/kopieren","sw"		' Fokus auf Eingabefeld Startwert
	FF_SetControl "Bilder der Liste umbennen/kopieren","bool_listwechsel", FF_GetProfile(RegSchluessel,"listwechsel")
	if FF_GetProfile(RegSchluessel,"umbenen") = "1" or Zielordner = "" Then
		FF_SetControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 1
		FF_EnableControl "Bilder der Liste umbennen/kopieren", "bool_listwechsel", 0
	End If
End Sub  

Sub Dialogaufbau_Meldung
	'** Start Dialog Meldung **
	FF_AddDialog "Meldung",300,90
	FF_AddControl "Meldung","meld1","EDIT",89,-1,212,61
	FF_SetControlStyle "Meldung","meld1",2048
	FF_AddControl "Meldung","Abbrechen","BUTTON",166,74,57,11
	FF_AddControl "Meldung","OK","BUTTON",231,74,57,11
	FF_AddControl "Meldung","img1","IMAGE",0,0,90,90
	FF_AddControl "Meldung","progress","PROGRESS",90,59,210,8
	'** End Dialog Meldung **
End Sub

Sub RenameFile(old_name, new_name)
	' old_name .... Dateiname mit vollstndigem Pfad der Datei
	' new_name .... nur der Dateiname ohne Pfad
	Dim fso, objFile, MTaste
	Dim btxt1, btxt2
	
	on error resume next
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set objFile = fso.GetFile(old_name)
	objFile.Name = new_name	
	if Err.Number = 58 Then
		btxt1 = "Weiter mit" & vbnewline & "nchstem Bild"
		btxt2 = "Vorgang" & vbnewline & "insgesamt abbrechen"
		'** Start Dialog Warnung **
		FF_AddDialog "Warnung",300,90
		FF_AddControl "Warnung","meld1","EDIT",89,-1,212,55
		FF_SetControlStyle "Warnung","meld1",2048
		FF_AddControl "Warnung",btxt1 ,"BUTTON",166,64,57,18
		FF_AddControl "Warnung",btxt2 ,"BUTTON",231,64,57,18
		FF_AddControl "Warnung","img1","IMAGE",0,0,90,90
		'** End Dialog Warnung **
		FF_SetControl "Warnung","img1", bild
		FF_SetControl "Warnung", "meld1",  "Fr das Bild" & vbNewLine & "   " & bild  & vbNewLine & "wrde der Vorgang dazu fhren, dass eine bestehende gleichnamige Datei berschrieben wird." & vbNewLine &  vbNewLine &  "Dieses Bild wird bersprungen!"
		do								' Auswertung Button im Dialog
			MTaste = FF_ShowDialog("Warnung")
			Select Case MTaste
				Case btxt2			' alles abbrechen
					Abbruchflag = 1
					FF_CloseDialog "Warnung"
					Exit Do
				Case btxt1			' weiter mit nchstem Bild
					FF_CloseDialog "Warnung"
					Exit Do
				Case "CANCEL"
					Abbruchflag = 1
					FF_CloseDialog "Warnung"
					Exit Do
			End Select
		loop
		
		fehlerflag = 1
	End If
	on error goto 0
End Sub

Sub WriteNewFile(old_name, new_name)
	' old_name .... Dateiname mit vollstndigem Pfad der Datei
	' new_name .... neuer Dateiname mit vollstndigem Pfad der Datei
	Dim fso, MTaste
	Dim btxt1, btxt2
	on error resume next
	Set fso = CreateObject("Scripting.FileSystemObject")
	fso.CopyFile old_name, new_name, False			' false = berschreiben nicht erlaubt
	if Err.Number = 58 Then
		
		btxt1 = "Weiter mit" & vbnewline & "nchstem Bild"
		btxt2 = "Vorgang" & vbnewline & "insgesamt abbrechen"
		'** Start Dialog Warnung **
		FF_AddDialog "Warnung",300,90
		FF_AddControl "Warnung","meld1","EDIT",89,-1,212,55
		FF_SetControlStyle "Warnung","meld1",2048
		FF_AddControl "Warnung",btxt1 ,"BUTTON",166,64,57,18
		FF_AddControl "Warnung",btxt2 ,"BUTTON",231,64,57,18
		FF_AddControl "Warnung","img1","IMAGE",0,0,90,90
		'** End Dialog Warnung **
		FF_SetControl "Warnung","img1", bild
		FF_SetControl "Warnung", "meld1",  "Fr das Bild" & vbNewLine & "   " & bild  & vbNewLine & "wrde der Vorgang dazu fhren, dass eine bestehende gleichnamige Datei berschrieben wird." & vbNewLine &  vbNewLine &  "Dieses Bild wird bersprungen!"
		do								' Auswertung Button im Dialog
			MTaste = FF_ShowDialog("Warnung")
			Select Case MTaste
				Case btxt2			' alles abbrechen
					Abbruchflag = 1
					FF_CloseDialog "Warnung"
					Exit Do
				Case btxt1			' weiter mit nchstem Bild
					FF_CloseDialog "Warnung"
					Exit Do
				Case "CANCEL"
					Abbruchflag = 1
					FF_CloseDialog "Warnung"
					Exit Do
			End Select
		loop
		
		fehlerflag = 1
	End If
	on error goto 0
End Sub

Sub Initalisierung_Registry
	' Registry schreiben
	FF_WriteProfile RegSchluessel,"Initialisierung", "1"
	FF_WriteProfile RegSchluessel,"praefix1", ""
	FF_WriteProfile RegSchluessel,"praefix", "_"
	FF_WriteProfile RegSchluessel,"stellen",  2
	FF_WriteProfile RegSchluessel,"start", 0
	FF_WriteProfile RegSchluessel,"schrittweite", 1
	FF_WriteProfile RegSchluessel,"behalten", 1
	FF_WriteProfile RegSchluessel,"umbenen", 1
	FF_WriteProfile RegSchluessel,"nurkopie", 0
	FF_WriteProfile RegSchluessel,"zielordner", ""
	FF_WriteProfile RegSchluessel,"listwechsel", 1
End Sub

Sub Registry_Schreiben
	' Registry schreiben
	FF_WriteProfile RegSchluessel,"praefix1", FF_GetControl("Bilder der Liste umbennen/kopieren", "praefix_edit")
	FF_WriteProfile RegSchluessel,"praefix", FF_GetControl("Bilder der Liste umbennen/kopieren", "binde")
	FF_WriteProfile RegSchluessel,"stellen", FF_GetControl("Bilder der Liste umbennen/kopieren", "combo_stellen")
	FF_WriteProfile RegSchluessel,"start", FF_GetControl("Bilder der Liste umbennen/kopieren", "sw")
	FF_WriteProfile RegSchluessel,"schrittweite", FF_GetControl("Bilder der Liste umbennen/kopieren", "schritt")
	FF_WriteProfile RegSchluessel,"behalten", FF_GetControl("Bilder der Liste umbennen/kopieren", "altnam")
	FF_WriteProfile RegSchluessel,"umbenen", FF_GetControl("Bilder der Liste umbennen/kopieren", "umbenen")
	FF_WriteProfile RegSchluessel,"kopie", FF_GetControl("Bilder der Liste umbennen/kopieren", "kopie")
	FF_WriteProfile RegSchluessel,"nurkopie", FF_GetControl("Bilder der Liste umbennen/kopieren", "nurkopie_opt")
	FF_WriteProfile RegSchluessel,"verkn_umn_opt", FF_GetControl("Bilder der Liste umbennen/kopieren", "verkn_umn_opt")
	FF_WriteProfile RegSchluessel,"verkn_opt", FF_GetControl("Bilder der Liste umbennen/kopieren", "verkn_opt")
	FF_WriteProfile RegSchluessel,"zielordner", Zielordner
	FF_WriteProfile RegSchluessel,"listwechsel", FF_GetControl("Bilder der Liste umbennen/kopieren", "bool_listwechsel")
End Sub

Function Ordnerauswahl
	Dim AuswahlTitel, StartOrdner, Dateiauswahl, Ordner
	On Error Resume Next
	AuswahlTitel = "Bitte Verzeichnis auswhlen" 
	StartOrdner = 17		' Arbeitsplatz
	Set Dateiauswahl = CreateObject("Shell.Application").BrowseForFolder(0,AuswahlTitel,16,StartOrdner) 
	Set Ordner = Dateiauswahl.Self 
	Ordnerauswahl = Ordner.Path
End Function

Sub BildView100 (Bild, Dialogname)
	' erstellt einen Dialog, in dem das bergebene Bild mit 100%-Skalierung angezeigt wird
	' Bilddatei -> vollstndiger Pfad der Bilddatei
	' Dialogname -> Bezeichung, die im Kopf des Dialogfensters angezeigt wird
	' Andreas Kleingnther, 161008
	
	Dim g_XUnits,g_YUnits
	Dim UnitX, UnitY
	Dim Bild_X, Bild_Y
	Const SM_CXSCREEN=0
    Const SM_CYSCREEN=1
	
    g_XUnits=FF_GetSystemMetrics(SM_CXSCREEN)*4\(CDbl(FF_GetDialogBaseUnits) Mod &h10000&)
    g_YUnits=FF_GetSystemMetrics(SM_CYSCREEN)*8\(CDbl(FF_GetDialogBaseUnits)  \  &h10000&)
	Bild_X = FF_GetImageFileWidth(Bild)
	Bild_Y = FF_GetImageFileHeight(Bild) 
	UnitX = Bild_X * g_XUnits / FF_GetSystemMetrics(0)
	UnitY = Bild_Y * g_YUnits / FF_GetSystemMetrics(1)
	
	 '** Start Dialog Dialogname **
	FF_AddDialog Dialogname, UnitX+1, UnitY+15		' +1 fr dezenten Rahmen, + 15 ft PLatz fr OK-Button
	FF_AddControl Dialogname,"img1","IMAGE",0 ,0 ,UnitX, UnitY		
	FF_AddControl Dialogname,"OK","BUTTON", UnitX-40, UnitY, 40, 12
	'** End Dialog Dialogname **
	FF_SetControl Dialogname, "img1", Bild
	REM FF_ShowDialog Dialogname					' Aufruf erfolgt oben
End Sub



' ** INI auslesen
Function ReadIni( myFilePath, mySection, myKey )
	' http://www.robvanderwoude.com/vbstech_files_ini.php
    ' Arguments:
    ' myFilePath  [string]  the (path and) file name of the INI file
    ' mySection   [string]  the section in the INI file to be searched
    ' myKey       [string]  the key whose value is to be returned

    Const ForReading   = 1
    Const ForWriting   = 2
    Const ForAppending = 8

    Dim intEqualPos
    Dim objFSO, objIniFile
    Dim strFilePath, strKey, strLeftString, strLine, strSection

    Set objFSO = CreateObject( "Scripting.FileSystemObject" )

    ReadIni     = ""
    strFilePath = Trim( myFilePath )
    strSection  = Trim( mySection )
    strKey      = Trim( myKey )

    If objFSO.FileExists( strFilePath ) Then
        Set objIniFile = objFSO.OpenTextFile( strFilePath, ForReading, False )
        Do While objIniFile.AtEndOfStream = False
            strLine = Trim( objIniFile.ReadLine )
			strLine = Killspace(strLine)		' behebt Probleme mit Leerzeichen am Anfang oder Ende 
            If LCase( strLine ) = "[" & LCase( strSection ) & "]" Then
                strLine = Trim( objIniFile.ReadLine )
                Do While Left( strLine, 1 ) <> "["
                    intEqualPos = InStr( 1, strLine, "=", 1 )
                    If intEqualPos > 0 Then
                        strLeftString = Trim( Left( strLine, intEqualPos - 1 ) )
                        If LCase( strLeftString ) = LCase( strKey ) Then
                            ReadIni = Trim( Mid( strLine, intEqualPos + 1 ) )
                            If ReadIni = "" Then
                                ReadIni = " "
                            End If
                            Exit Do
                        End If
                    End If
                    If objIniFile.AtEndOfStream Then Exit Do
                    strLine = Trim( objIniFile.ReadLine )
                Loop
            Exit Do
            End If
        Loop
        objIniFile.Close
    Else
        msgbox strFilePath & "existiert nicht"
        Exit Function
    End If
End Function

Function Killspace (Zeichenkette)
	' entfernt aus einer ZeichenketteLeerzeichen hinter [ bzw. vor ] 
	Killspace = Replace(Zeichenkette, "[ ", "[")
	Killspace = Replace(Zeichenkette, " ]", "]")
End Function

Function ExecHidden (CMD)
  ' v3.A - Quelle: http://dieseyer.de/dse-wsh-scr-b.html
  Dim FileOut, oWsh, Tmp

  CMD = Replace( CMD, """", """""" )
  Tmp = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%Temp%") & "\" & "ExecHidden.VBS"
   Set FileOut  = CreateObject("Scripting.FileSystemObject").OpenTextFile( Tmp , 2, true)
	FileOut.WriteLine( " Set      oExec = WScript.CreateObject(""WScript.Shell"").Exec(""" & CMD & """) " )
	FileOut.WriteLine( " WScript.CreateObject(""WScript.Shell"").Environment( ""volatile"" )( ""Eregbnis"" ) = oExec.StdOut.ReadAll() " )
	FileOut.Close
   Set FileOuT  = nothing
   Set oWsh = CreateObject("WScript.Shell")
	   oWsh.Run "CScript.exe //NOLOGO " & Tmp , 0, true
  ExecHidden = oWsh.Environment("volatile")( "Eregbnis" )
  'zum Lschen der 'Tmp-Datei nchste Zeile frei geben
   CreateObject("Scripting.FileSystemObject").DeleteFile( Tmp )
End Function


Sub Log(Parameter, t1, t2, t3)
      ' ***************************************************************************************
      ' * schreibt bis zu drei Werte t1 bis t3 in die Textdatei ff_testlog.txt im Scriptordner
      ' * mehrere Werte werden durch Semikolon voneinander getrennt und
      ' * in einer Zeile dargestellt,
      ' * optional wird eine Zeile mit Datum und Uhrzeit voran gestellt
      ' * Parameter wird durch Addition folgender Werte gebildet:
      ' *     0 - vorhandene Datei ergnzen bzw. Datei neu erstellen
      ' *     1 - ggf. vorhandene Datei lschen und neu erstellen
      ' *     2 - Zeitstempel einfgen
      ' **************************************************************************************
 
      Dim fso, tf
      Dim Werte
      Const ForAppending = 8
      Dim Logdatei
      Logdatei = FF_GetFFPathEx(2) & "\ff_testlog.txt"
 
      set fso = CreateObject("Scripting.FileSystemObject")
 
      if Parameter = 1 or  Parameter = 3 Then            ' Datei lschen
          If (fso.FileExists(Logdatei)) Then
              fso.DeleteFile(Logdatei)
          End If
      End If
      if Parameter = 2 or Parameter = 3 Then             ' mit Zeitstempel
          Werte = "----- " & Date & " - " & Time & " -----" & vbNewLine
      End If
 
      if t1 <> "" then Werte = Werte & t1
      if t2 <> "" then Werte = Werte & "; " & t2
      if t3 <> "" then Werte = Werte & "; " & t3
 
      If not (fso.FileExists(Logdatei)) Then
          Set tf = fso.CreateTextFile(Logdatei, True)
          tf.Close
      End If
 
      Set tf = fso.OpenTextFile(Logdatei, ForAppending, True)
      tf.WriteLine(Werte)
      tf.Close
  End Sub


